
#include <iostream>
#include <fstream>

#include <xtl2.h>

class data {
 private:
	int x, y;
	int *px, *rx, *p2x;
	char gif[100];
	list<int> li;

 public:
 	data() {}
	data(int i):x(i),y(i*2),px(NULL),rx(&x),p2x(&x) {li.insert(li.end(), 3);}

	template <class Visitor, class Kind>
	void composite(Visitor& visitor, Kind) {
		visitor>>x>>y>>xtl::pointer(px)>>xtl::reference(rx);
		visitor>>xtl::opaque(gif,100);
		visitor>>xtl::pointer(p2x);
		visitor>>li;
	}
};

class dumper {
 public:
 	typedef xtl::destructor kind;

	template <class Type>
	void visit(Type const& data) {
		cout<<data<<endl;
	}

	template <class Type, class Idx, class CharSet>
	void visit(Type* data, Idx size, CharSet) {
		cout<<"raw data..."<<endl;
	}

	xtl::destructor_bucket<int,int> refs;
};

int main() {
	std::ofstream ofstr("test.raw");
	xtl::XDR_output<ostream> oform(ofstr);

	data od(4);
	oform>>od;

	std::ifstream ifstr("test.raw");
	xtl::XDR_input<istream> iform(ifstr);

	data id;
	iform>>id;

	dumper d;
	d>>id;
}


