
#include <iostream>

#include <xtl2.h>

class data {
 private:
	int x, y;
	int *px, *rx, *p2x;
	char gif[100];
	list<int> li;

 public:
 	data() {}
	data(int i):x(i),y(i*2),px(NULL),rx(&x),p2x(&x) {li.insert(li.end(), 3);}

	template <class Visitor, class Kind>
	void composite(Visitor& visitor, Kind) {
		visitor>>x>>y>>xtl::pointer(px)>>xtl::aliased(xtl::reference(rx), visitor.refs);
		visitor>>xtl::opaque(gif,100);
		visitor>>xtl::aliased(xtl::pointer(p2x), visitor.refs);
		visitor>>li;
	}
};

class dumper {
 public:
 	typedef xtl::destructor kind;

	template <class Type>
	void visit(Type const& data) {
		cout<<data<<endl;
	}

	template <class Type, class Idx, class CharSet>
	void visit(Type* data, Idx size, CharSet) {
		cout<<"raw data..."<<endl;
	}

	xtl::destructor_bucket<int,int> refs;
};

class my_coiso: public xtl::XDR_output<xtl::buffer> {
 public:
	my_coiso(xtl::buffer& buf):xtl::XDR_output<xtl::buffer>(buf) {}

	xtl::destructor_bucket<int,int> refs;
};

class my_coisi: public xtl::XDR_input<xtl::buffer> {
 public:
	my_coisi(xtl::buffer& buf):xtl::XDR_input<xtl::buffer>(buf) {}

	xtl::constructor_bucket<int,int> refs;
};

int main() {
	char buf[1000];

	xtl::buffer ob(buf, 1000);
	my_coiso oform(ob);

	data od(4);
	oform>>od;

	xtl::buffer ib(buf, 1000);
	my_coisi iform(ib);

	data id;
	iform>>id;

	dumper d;
	d>>id;
}
